/**
 * Created by liz on 2015/11/2.
 */
var co = require('co');
var express = require('express');
var carService = require('../service/carService');
var carAPI = (function(){
    function carAPI(){
        var router = new express();
        router.get('/brand', this.getAllBrand);
        router.get('/series',this.getSeries);
        router.get('/', this.getCarInfo);
        this.router = router;
    }

    carAPI.prototype.getRouter = function(){
        return this.router;
    };

    //查找所有的汽车品牌
    carAPI.prototype.getAllBrand = function(req,res){
        co(function*(){
            var brands = yield carService.getAllBrandsG();
            res.json({status:"ok",brands:brands});
        }).catch(function(ex){
            res.status(500).send(ex.stack);
        });
    };

    //根据品牌查找车系
    carAPI.prototype.getSeries = function(req,res){
        co(function*(){
            var brandCode = req.query.brandId;
            var series = yield carService.getSeriesG(brandCode);
            res.json({status:"ok",series:series});
        }).catch(function(ex){
            res.status(500).send(ex.stack);
        });
    }

    //查询车辆信息
    carAPI.prototype.getCarInfo = function(req,res){
        co(function*(){
            var wx_oid = req.query.wx_oid;
            var result = yield carService.getCarInfoG(wx_oid);
            res.json({status:"ok",carinfo:result[0]});
        }).catch(function(ex){
            res.status(500).send(ex.stack);
        });
    }


    return carAPI;
})();

module.exports = carAPI;
