/**
 * Created by liz on 2015/11/2.
 */
var co = require('co');
var express = require('express');
var careService = require('../service/careService');
var ApiHelper = require('./ApiHelper');
var careAPI = (function(){
    function careAPI(){
        var router = new express();
        router.get('/', this.getAllCareConfig);
        router.post('/:vid',this.addCare);
        router.get('/:vid',this.getCares);
        this.router = router;
    }

    careAPI.prototype.getRouter = function(){
        return this.router;
    };

//获取所有保养项字典数据
    careAPI.prototype.getAllCareConfig = function(req, res){
        co(function*(){
            var sid = req.query.sid;
            var result = yield careService.getCareConfigG(sid);
            res.json({status:"ok",cfgCare:result});
        }).catch(function(ex){
            debug(ex.stack);
            res.status(500).send(ex.stack);
        });
    };

    //增加保养
    careAPI.prototype.addCare = function(req, res){
        co(function*(){
            var data = req.body;
            var vehicleId = req.params.vid;
            var result = yield careService.AddCareDataG(vehicleId,data);
            res.json({ status:"ok", ret: result });
        }).catch(function (ex) {
            res.status(500).send(ex.stack);
        });
    };

    // Query all the care records for the vehicle
    careAPI.prototype.getCares = function(req, res){
        co(function*(){
            var args = ApiHelper.makeQueryArgs(req.query);
            var vid = req.params.vid;
            var result = yield [careService.GetCareDataCountG({car_id:vid}),
                careService.GetCareDataG({car_id: vid},"care_id-",args.pageSize, args.nextMarker)];
            res.json({total: result[0], care: result[1] });
        }).catch(function (ex) {
            debug(ex.stack);
            res.status(500).send(ex.stack);
        });
    };


    return careAPI;
})();

module.exports = careAPI;
