/**
 * Created by liz on 2015/11/2.
 */
var co = require('co');
var express = require('express');
var fs = require('fs');
var path = require('path');
var fileServie = require('../service/fileService');
var fileAPI = (function(){
    function fileAPI(){
        var router = new express();
        router.get('/download', this.download);
        router.get('/version', this.getVersion);
        this.router = router;
    }

    fileAPI.prototype.getRouter = function(){
        return this.router;
    };

    fileAPI.prototype.getVersion = function(req,res){
        co(function*(){
            var shortname = req.query.shortname;
            var result = yield fileServie.getVersion(shortname);
            if(result){
                res.json({status:"ok",data:result});
            }else{
                res.json({status:"failure",data:"无相关版本信息"});
            }
        }).catch(function(ex){
            debug(ex.stack);
            res.status(500).send(ex.stack);
        });
    };

    //download file
    fileAPI.prototype.download = function(req,res){
        var filePath = __dirname +"\\CheYunBaotest.apk";
        fs.exists(filePath,function(exist){
            if(exist) {
                res.setHeader('Accept-Range', 'bytes');
                res.writeHead(200, 'Partial Content', {
                    'Content-Type' : 'application/octet-stream'
                });
                fs.stat(filePath, function(error, state){
                    if(error) throw error;
                    var fileSize = state.size;
                    fReadStream = fs.createReadStream(filePath, {
                        encoding : 'binary',
                        bufferSize : 1024 * 1024,
                        start : 0,
                        end : fileSize
                    });
                    fReadStream.on('data', function(chunk) {
                        res.write(chunk, 'binary');
                    });
                    fReadStream.on('end', function() {
                        res.end();
                    });
                });
            } else {
                res.json({status:"failure",msg:"文件不存在"});
            }
        })
    };



    return fileAPI;
})();

module.exports = fileAPI;
