/**
 * Created by liz on 2015/11/2.
 */
var co = require('co');
var express = require('express');
var registerService = require('../service/registerService');
var carService = require('../service/carService');
var s4Service = require('../service/s4Service');
var Promise = require('promise');
var userService = require('../service/userService');
var registerAPI = (function(){
    function registerAPI(){
        var router = new express();
        router.post('/', this.register);
        this.router = router;
    }

    registerAPI.prototype.getRouter = function(){
        return this.router;
    };

    /**
     * 注册
     * @param req
     * @param res
     */
    registerAPI.prototype.register = function(req, res){
        co(function*(){
            var s4Info = yield registerAPI.getFacilitatorG("服务商");
            var regisInfo = req.body;
            var usercount = yield userService.checkUsernameG(regisInfo.username,s4Info[0].id);
            if(usercount > 0)res.json({status:'400',message:"账号已被注册"});
            var phonecount = yield userService.checkPhoneG(regisInfo.phone,s4Info[0].id);
            if(phonecount > 0)res.json({status:'400',message:"手机号已被注册"});
            var ccInfo = yield carService.findCarCloudNoG(regisInfo.carcloudno, s4Info[0].id);
            if(ccInfo.length > 0 && ccInfo[0].id > 0){
                var rows = yield carService.checkBindByCarG(ccInfo[0].id);
                if(rows === 0){
                    save(regisInfo,s4Info,res,ccInfo);
                }else{
                    res.json({status:'400',message:"车云编号已被注册"});
                }
            }else{
                res.json({status:'400',message:"车云编号不存在"});
            }
        }).catch(function(ex){
            res.status(500).send(ex.stack);
        });
    };

    /**
     * 获取服务商
     * @param name
     */
    registerAPI.getFacilitatorG = function * (name){
            var s4Info = yield s4Service.findS4ByName(name);
            if(s4Info.length > 0 && s4Info[0].id > 0){
                 return s4Info;
            }else{
                var postData = {name:"服务商", short_name:"fws"};
                var result = yield s4Service.saveG(postData);
                s4Info = yield s4Service.findS4ById(result.insertId);
                 return s4Info;
            }
    }

    /**
     * save
     * @param regisInfo
     * @param s4Info
     */
    var save = function(regisInfo, s4Info, res, ccInfo){
        co(function*(){
            var postData = {
                s4_id : s4Info[0].id,
                name : regisInfo.username,
                pwd : regisInfo.password,
                phone : regisInfo.phone,
                nick : regisInfo.username,
                last_login_time : new Date(),
                tel_pwd : "00000",
                wx_oid : regisInfo.username+":"+regisInfo.phone
            };
            var result = yield registerService.registerUserG(postData);
            if(result.insertId > 0)
            {
                var postData_1 = {
                s4_id : s4Info[0].id,
                acc_id : result.insertId,
                car_id : ccInfo[0].id,
                user_type : 1,
                join_time : new Date()
               };
                var result_1 =  yield registerService.registerRelativeG(postData_1);
                if(result_1.insertId > 0){
                    res.json({status:'ok',message:"注册成功!"});
                }
                else{
                    res.json({status:'400',message:"注册失败!"});
                }
            }else{
                res.json({status:'400',message:"注册失败!"});
            }
        }).catch(function(ex){
            res.status(500).send(ex.stack);
        });
    }



    return registerAPI;
})();

module.exports = registerAPI;
