/**
 * Created by liz on 2015/11/2.
 */
var co = require('co');
var express = require('express');
var userService = require('../service/userService');
var registerAPI = require('./registerAPI');

var userAPI = (function(){
    function userAPI(){
        var router = new express();
        router.get('/checkname', this.checkName);
        router.get('/checkphone', this.checkPhone);
        router.get('/login', this.login);
        router.post('/resetpwd', this.resetpwd);
        this.router = router;
    }

    userAPI.prototype.getRouter = function(){
        return this.router;
    };

    /**
     * 检查用户名是否已存在
     * @param req
     * @param res
     */
    userAPI.prototype.checkName = function(req, res){
        co(function*(){
            var username = req.query.username;
            var s4Info = yield registerAPI.getFacilitatorG("服务商");
            var count = yield userService.checkUsernameG(username,s4Info[0].id);
            res.json({status:'ok',total:count});
        }).catch(function(ex){
            res.status(500).send(ex.stack);
        });
    };

    /**
     * 检查电话号码是否被注册
     * @param req
     * @param res
     */
    userAPI.prototype.checkPhone = function(req, res){
        co(function*(){
            var username = req.query.phone;
            var s4Info = yield registerAPI.getFacilitatorG("服务商");
            var count = yield userService.checkPhoneG(username,s4Info[0].id);
            res.json({status:'ok',total:count});
        }).catch(function(ex){
            res.status(500).send(ex.stack);
        });
    }


    /**
     * 登录
     * @param req
     * @param res
     */
    userAPI.prototype.login = function(req,res){
        co(function*(){
            var username = req.query.username;
            var pwd = req.query.pwd;
            var s4Info = yield registerAPI.getFacilitatorG("服务商");
            var userInfo = yield userService.loginG(username, pwd, s4Info[0].id);
            if(userInfo != null){
                res.json({status:'ok',user:userInfo});
            }else{
                res.json({status:'failure'});
            }
        }).catch(function(ex){
            res.status(500).send(ex.stack);
        });
    }


    /**
     * 重置密码
     * @param req
     * @param res
     */
    userAPI.prototype.resetpwd = function(req, res){
        co(function*(){
            var body = req.body;
            var newpwd = body.newpwd;
            var phone = body.phone;
            var s4Info = yield registerAPI.getFacilitatorG("服务商");
            var result = yield userService.resetpwdG(phone, s4Info[0].id, newpwd);
            if(result.affectedRows > 0){

                res.json({status:'ok'});
            }else{
                res.json({status:'failure'});
            }
        }).catch(function(ex){
            res.status(500).send(ex.stack);
        });
    }

    return userAPI;
})();

module.exports = userAPI;
