/**
 * Created by liz on 2015/11/3.
 */
var Promise = require('promise');
var mysql = require('@incar/mysql-pool');
var util = require('util');
var Entity = require('./Entity');

module.exports = (function() {
    function careService() {

    }

    careService.FromJson = function(src){
        return Entity.subclass(src, careService);
    };

    careService.getCareConfigG = function * (sid){
        var sql = "SELECT * FROM t_cfg_care_period WHERE s4_id = ?";
        return yield mysql.pool.queryP(sql, [sid]);
    }

    // 增加保养记录
    careService.AddCareDataG = function*(vehicleId, data){
        // 产生保养记录号
        var sql = "SELECT max(care_id) AS care_id FROM t_car_care WHERE car_id = ?";
        var rows = yield mysql.pool.queryP(sql, [vehicleId]);
        var careId = rows[0].care_id;
        if(!careId) careId = 0;
        careId++;
        var sqlValue;
        var args = [vehicleId, careId];
        var sqlTemplate = "INSERT t_car_care(car_id,care_id,cfg_id,mileage,tm,cost,cfgName)\n" +
            "SELECT ?, ?, cfg_id, mileage, tm, cost,cfgName\n" +
            "FROM (%s)T";
        for(var i=0; i<data.length; i++){
            if(i == 0)  sqlValue = "SELECT ? AS cfg_id, ? as mileage, ? as tm, ? as cost,? as cfgName";
            else sqlValue += "\n\tUNION SELECT ?,?,?,?,?";
            args.push(data[i].cfg_id);
            args.push(data[i].mileage);
            args.push(data[i].tm);
            args.push(data[i].cost);
            args.push(data[i].cfgName);
        }
        sql = util.format(sqlTemplate, sqlValue);
        yield mysql.pool.queryP(sql, args);
        return careId;
    };

    // 批理查询保养纪录
    careService.GetCareDataG = function*(filter, sortBy, pageSize, nextMarker){
        var query = Entity.assemblyPagingSQL("v_car_care", filter, sortBy, pageSize, nextMarker);
        var rows = yield mysql.pool.queryP(query.sql, query.args);

        // 按car_id组织对象
        var careIdArray = {};
        rows.forEach(function(row){
            if(!careIdArray[row.car_id])
                careIdArray[row.car_id] = [];
            careIdArray[row.car_id].push(row.care_id);
        });

        var tasks = [];
        for(var car_id in careIdArray){
            tasks.push(careService.GetCareDataByIdArrayG(car_id, careIdArray[car_id]));
        }

        var data = [];
        var results = yield tasks;
        results.forEach(function(result){
            result.forEach(function(care){
                data.push(care);
            });
        });

        return data;
    };

    // 批量按id查询对象
    careService.GetCareDataByIdArrayG = function*(car_id, idArray){
        var tmpName = mysql.genTmpTableName();
        yield mysql.storyIdArrayP(tmpName, idArray);
        var sql = "SELECT S.*, P.*\n" +
            "FROM t_car_care S\n" +
            "\tJOIN t_car C ON S.car_id = C.id\n" +
            "\tLEFT JOIN t_cfg_care_period P ON P.s4_id = C.s4_id and P.id = S.cfg_id\n" +
            "\tJOIN ?? T ON S.care_id = T.id\n" +
            "WHERE S.car_id = ?";
        var rows = yield mysql.pool.queryP(sql, [tmpName, car_id]);
        yield mysql.dropTableP(tmpName);

        var cares = {};
        var data = [];
        rows.forEach(function(row){
            if(!cares[row.care_id]) {
                cares[row.care_id] = careService.FromJson({ car_id: car_id, care_id: row.care_id, items: {} });
                data.push(cares[row.care_id]);
            }
            cares[row.care_id].items[row.cfg_id] = row;
        });
        return data;
    };

    // 保养纪录数目
    careService.GetCareDataCountG = function*(filter){
        var query = Entity.assemblyPagingSQL("v_car_care", filter);
        var rows = yield mysql.pool.queryP(query.sqlCount, query.args);
        return rows[0].rowsCount;
    };

    return careService;
})();