/**
 * Created by liz on 2015/11/3.
 */
var Promise = require('promise');
var mysql = require('@incar/mysql-pool');
var Entity = require('./Entity');
module.exports = (function() {
    function userService() {

    }

    // 从一个JSON对象构造Staff对象,通常JSON对象由数据库查询得到
    userService.FromJson = function(src){
        return Entity.subclass(src, userService);
    };

    /**
     * 检查用户名是否已存在
     * @param username
     * @returns {rowsCount|*}
     */
    userService.checkUsernameG = function * (username, s4Id){
        var sql = "select count(*) as rowsCount from t_account where name = ? and s4_id = ? ";
        var rows = yield mysql.pool.queryP(sql,[username, s4Id]);
        return rows[0].rowsCount;
    }

    /**
     * 检查电话号码是否已存在
     * @param phone
     * @returns {rowsCount|*}
     */
    userService.checkPhoneG = function * (phone, s4Id){
        var sql = "select count(*) as rowsCount from t_account where phone = ? and s4_id = ?";
        var rows = yield mysql.pool.queryP(sql,[phone, s4Id]);
        console.log("rows:" + rows[0].rowsCount);
        return rows[0].rowsCount;
    }

    /**
     * 登录
     * @param username
     * @param pwd
     * @returns {rowsCount|*}
     */
    userService.loginG = function * (username, pwd, s4_id){
        var sql = "select * from t_account where name = ? and pwd = ? and s4_id = ?";
        var rows = yield mysql.pool.queryP(sql,[username,pwd,s4_id]);
        return rows[0];
    }

    /**
     * 重置密码
     * @param id
     * @param pwd
     */
    userService.resetpwdG = function * (phone, s4_id, newpwd){
        var sql = "update t_account set pwd = ? where phone = ? and s4_id = ? ";
        var result = yield mysql.pool.queryP(sql,[newpwd,phone,s4_id]);
        return result;
    }

    userService.modifywxoid
   return userService;
})();